/// <reference types="react" />
import * as adaptor from './adaptor';
import * as core from './core';
export interface RouterOptions {
    scrollOnMissingHash?: 'top' | 'preserve';
}
export declare function createRouter<AppRoutes extends Array<core.Route<any, any, any>>>(appRoutes: AppRoutes, options?: RouterOptions): {
    useRouter: (initialURL: string) => {
        location: core.RouteLocation<core.InferRoute<AppRoutes>, core.InferRoute<AppRoutes>["meta"]> | {
            name: "404";
            params: undefined;
            query: core.RouteQuery;
            hash: string;
            meta: core.InferRoute<AppRoutes>["meta"];
            landing: core.LandingProps;
        };
        navigate: (ref: core.RouteRef<core.InferRoute<AppRoutes>>, landing?: core.LandingProps | undefined) => void;
        redirect: (ref: core.RouteRef<core.InferRoute<AppRoutes>>, landing?: Pick<core.LandingProps, "unloading" | "replaced"> | undefined) => void;
        buildHref: (ref: core.RouteRef<core.InferRoute<AppRoutes>>) => string;
    };
    RouterContext: import("react").Context<{
        location: core.RouteLocation<core.InferRoute<AppRoutes>, core.InferRoute<AppRoutes>["meta"]> | {
            name: "404";
            params: undefined;
            query: core.RouteQuery;
            hash: string;
            meta: core.InferRoute<AppRoutes>["meta"];
            landing: core.LandingProps;
        };
        navigate: (ref: core.RouteRef<core.InferRoute<AppRoutes>>, landing?: core.LandingProps | undefined) => void;
        redirect: (ref: core.RouteRef<core.InferRoute<AppRoutes>>, landing?: Pick<core.LandingProps, "unloading" | "replaced"> | undefined) => void;
        buildHref: (ref: core.RouteRef<core.InferRoute<AppRoutes>>) => string;
    }>;
    RouterLink: <ExtraLinkComponentProps extends {
        [key: string]: any;
    } = {}>({ to, target, rel, mode, tag, children, component, onClick: customOnClick, ...componentProps }: {
        to: core.RouteRef<core.InferRoute<AppRoutes>>;
        target?: string | undefined;
        rel?: string | undefined;
        mode?: "anchor" | "block" | undefined;
        tag?: string | undefined;
        children?: adaptor.ComponentChildren;
        component?: adaptor.ReactElement<any, string | ((props: any) => adaptor.ReactElement<any, any> | null) | (new (props: any) => import("react").Component<any, any, any>)> | undefined;
        onClick?: ((e: MouseEvent) => any) | undefined;
    } & ExtraLinkComponentProps) => adaptor.ReactElement<any, string | ((props: any) => adaptor.ReactElement<any, any> | null) | (new (props: any) => import("react").Component<any, any, any>)>;
    resolveLocation: (url: string) => core.RouteLocation<core.InferRoute<AppRoutes>, core.InferRoute<AppRoutes>["meta"]> | {
        name: "404";
        params: undefined;
        query: core.RouteQuery;
        hash: string;
        meta: core.InferRoute<AppRoutes>["meta"];
        landing: core.LandingProps;
    };
    refToLocation: (ref: core.RouteRef<core.InferRoute<AppRoutes>>, landing?: core.LandingProps) => core.RouteLocation<core.InferRoute<AppRoutes>, core.InferRoute<AppRoutes>["meta"]> | {
        name: "404";
        params: undefined;
        query: core.RouteQuery;
        hash: string;
        meta: core.InferRoute<AppRoutes>["meta"];
        landing: core.LandingProps;
    };
    buildHref: (ref: core.RouteRef<core.InferRoute<AppRoutes>>) => string;
};
